import java.net.Socket;
import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.OutputStream;

public class TM
	{

// Communicates with tmumon and controls the Transmogrifier

public final static int CONTROLPORT = 3462;
public final static int DATAPORT = 9100;
public final String DEFAULT_HOSTNAME = "skynet.eecg.toronto.edu";

Socket controlSocket;
PrintWriter controlOut;
BufferedReader controlIn;

Socket dataSocket;
InputStream dataIn;
OutputStream dataOut;

public TM()
	throws java.io.IOException
	{
	this(null);
}



public TM(String hostname)
	throws java.io.IOException
	{
	if(hostname == null) {
		hostname = DEFAULT_HOSTNAME;
	}

	controlSocket = new Socket(hostname, CONTROLPORT);
	controlOut = new PrintWriter(controlSocket.getOutputStream());
	controlIn = new BufferedReader(
		new InputStreamReader(controlSocket.getInputStream()));

	dataSocket = new Socket(hostname, DATAPORT);
	dataIn = dataSocket.getInputStream();
	dataOut = dataSocket.getOutputStream();
}



public String getDesignDateString()
	throws java.io.IOException
	{

	// Example of how to send a request to the control port and read the
	// reply

	String s;
	String result;

	send("getdesigndate ");
	result = readLine();
// System.out.println("read " + s);
	s = readLine();		// Discard blank line
	return(result);
}



public int readData(byte[] b, int off, int len)
	throws java.io.IOException
	{

	// Read len bytes from the data socket

	int originalLen = len;

	while(len > 0) {
		int retval = dataIn.read(b, off, len);

		len -= retval;
		off += retval;
	}

	return(originalLen);
}



public void writeData(byte[] b, int off, int len)
	throws java.io.IOException
	{

	// Write len bytes to the data socket

	dataOut.write(b, off, len);
}



void send(String command)
	throws java.io.IOException
	{
	controlOut.println(command);
	controlOut.flush();
}



void sendCommand(String command)
	throws java.io.IOException
	{
	String s;

	send(command);
	s = readLine();
}



String readLine()
	throws java.io.IOException
	{
	return(controlIn.readLine());
}

}
