
/* Set a port in the circuit */

#include <stdlib.h>
#include <stdio.h>
#include <netinet/in.h>

#define MAX_PORT_BYTES	4096

char data[MAX_PORT_BYTES];

main(argc, argv)
	int argc;
	char *argv[];
	{
	int port, value, nbits, portbytes, i;

	if(argc != 3) {
		fprintf(stderr, "usage: tmsetvar name nnn\n");
		exit(1);
		}

	tm_init("");

	if((port = tm_open(argv[1], "w")) < 0) {
		printf("tmsetvar: Can't open port %s\n", argv[1]);
		exit(1);
		}

	if((nbits = tm_get_port_width(argv[1])) < 0) {
		printf("tmsetvar: Can't get width of port %s\n", argv[1]);
		exit(1);
		}

	portbytes = (nbits + 7) / 8;

	if(portbytes > MAX_PORT_BYTES) {
		printf("tmsetvar: port too wide\n");
		exit(1);
		}

	value = atoi(argv[2]);

	if(htons(1) == 1) {
		/* This machine is big-endian */

		for(i=0; i<portbytes; i++) {
			data[portbytes-1-i] = value & 0xFF;
			value >>= 8;
			}
		}
	else {
		/* This machine is little-endian */

		for(i=0; i<portbytes; i++) {
			data[i] = value & 0xFF;
			value >>= 8;
			}
		}

	if(tm_write(port, data, portbytes) != portbytes) {
		fprintf(stderr, "tmsetvar: error in writing to value port\n");
		exit(1);
		}

	tm_close(port);
	exit(0);
	}
